io.vertx.core.http

## Class WebSocketConnectOptions

- java.lang.Object
- - io.vertx.core.http.RequestOptions
  - - io.vertx.core.http.WebSocketConnectOptions

-     public class WebSocketConnectOptions
      extends RequestOptions

  Options describing how an `HttpClient` connect a `WebSocket`.
  Author:
    Julien Viet

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static boolean` | `DEFAULT_ALLOW_ORIGIN_HEADER` The default WebSocket allow origin header = `true`
    `static ProxyOptions` | `DEFAULT_PROXY_OPTIONS` The default value for proxy options = `null`
    `static List<String>` | `DEFAULT_SUB_PROTOCOLS` The default WebSocket sub protocols = `null`
    `static WebsocketVersion` | `DEFAULT_VERSION` The default WebSocket version = `WebsocketVersion.V13`

    - ### Fields inherited from class io.vertx.core.http.RequestOptions

      `DEFAULT_FOLLOW_REDIRECTS, DEFAULT_HOST, DEFAULT_HTTP_METHOD, DEFAULT_PORT, DEFAULT_SERVER, DEFAULT_SSL, DEFAULT_TIMEOUT, DEFAULT_URI`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `WebSocketConnectOptions()`
    `WebSocketConnectOptions(JsonObject json)`
    `WebSocketConnectOptions(WebSocketConnectOptions other)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `WebSocketConnectOptions` | `addHeader(CharSequence key, CharSequence value)` Add a request header.
    `WebSocketConnectOptions` | `addHeader(CharSequence key, Iterable<CharSequence> values)`
    `WebSocketConnectOptions` | `addHeader(String key, String value)` Add a request header.
    `WebSocketConnectOptions` | `addSubProtocol(String subprotocol)` Add a WebSocket sub protocol to use.
    `boolean` | `getAllowOriginHeader()`
    `ProxyOptions` | `getProxyOptions()` Get the proxy options override for connections
    `List<String>` | `getSubProtocols()`
    `WebsocketVersion` | `getVersion()`
    `WebSocketConnectOptions` | `putHeader(CharSequence key, CharSequence value)` Set a request header.
    `WebSocketConnectOptions` | `putHeader(CharSequence key, Iterable<CharSequence> values)`
    `WebSocketConnectOptions` | `putHeader(String key, String value)` Set a request header.
    `WebSocketConnectOptions` | `setAllowOriginHeader(boolean allowOriginHeader)` Set whether to add the `origin` header to the WebSocket handshake request, enabled by default.
    `WebSocketConnectOptions` | `setHeaders(MultiMap headers)` Set request headers from a multi-map.
    `WebSocketConnectOptions` | `setHost(String host)` Set the host name to be used by the client request.
    `WebSocketConnectOptions` | `setPort(Integer port)` Set the port to be used by the client request.
    `RequestOptions` | `setProxyOptions(ProxyOptions proxyOptions)` Override the `HttpClientOptions.setProxyOptions(ProxyOptions)` proxy options for connections.
    `WebSocketConnectOptions` | `setSsl(Boolean ssl)` Set whether SSL/TLS is enabled.
    `WebSocketConnectOptions` | `setSubProtocols(List<String> subProtocols)` Set the WebSocket sub protocols to use.
    `WebSocketConnectOptions` | `setTimeout(long timeout)` Sets the amount of time after which if the WebSocket handshake does not happen within the timeout period an `WebSocketHandshakeException` will be passed to the exception handler and the connection will be closed.
    `WebSocketConnectOptions` | `setURI(String uri)` Set the request relative URI.
    `WebSocketConnectOptions` | `setVersion(WebsocketVersion version)` Set the WebSocket version.
    `JsonObject` | `toJson()`

    - ### Methods inherited from class io.vertx.core.http.RequestOptions

      `getFollowRedirects, getHeaders, getHost, getMethod, getPort, getServer, getTimeout, getTraceOperation, getURI, isSsl, removeHeader, removeHeader, setAbsoluteURI, setAbsoluteURI, setFollowRedirects, setMethod, setServer, setTraceOperation`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_PROXY_OPTIONS

          public static final ProxyOptions DEFAULT_PROXY_OPTIONS

      The default value for proxy options = `null`

    - #### DEFAULT_VERSION

          public static final WebsocketVersion DEFAULT_VERSION

      The default WebSocket version = `WebsocketVersion.V13`

    - #### DEFAULT_SUB_PROTOCOLS

          public static final List<String> DEFAULT_SUB_PROTOCOLS

      The default WebSocket sub protocols = `null`

    - #### DEFAULT_ALLOW_ORIGIN_HEADER

          public static final boolean DEFAULT_ALLOW_ORIGIN_HEADER

      The default WebSocket allow origin header = `true`
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### WebSocketConnectOptions

          public WebSocketConnectOptions()

    - #### WebSocketConnectOptions

          public WebSocketConnectOptions(WebSocketConnectOptions other)

    - #### WebSocketConnectOptions

          public WebSocketConnectOptions(JsonObject json)

  - ### Method Detail

    - #### getVersion

          public WebsocketVersion getVersion()

      Returns:
        the WebSocket version

    - #### setVersion

          public WebSocketConnectOptions setVersion(WebsocketVersion version)

      Set the WebSocket version.
      Returns:
        a reference to this, so the API can be used fluently

    - #### getSubProtocols

          public List<String> getSubProtocols()

      Returns:
        the list of WebSocket sub protocols or `null` if there are none

    - #### setSubProtocols

          public WebSocketConnectOptions setSubProtocols(List<String> subProtocols)

      Set the WebSocket sub protocols to use.
      Returns:
        a reference to this, so the API can be used fluently

    - #### addSubProtocol

          public WebSocketConnectOptions addSubProtocol(String subprotocol)

      Add a WebSocket sub protocol to use.
      Returns:
        a reference to this, so the API can be used fluently

    - #### getProxyOptions

          public ProxyOptions getProxyOptions()

      Get the proxy options override for connections
      Overrides:
        `getProxyOptions` in class `RequestOptions`
      Returns:
        proxy options override

    - #### setProxyOptions

          public RequestOptions setProxyOptions(ProxyOptions proxyOptions)

      Override the `HttpClientOptions.setProxyOptions(ProxyOptions)` proxy options for connections.
      Overrides:
        `setProxyOptions` in class `RequestOptions`
      Parameters:
        `proxyOptions` - proxy options override object
      Returns:
        a reference to this, so the API can be used fluently

    - #### getAllowOriginHeader

          public boolean getAllowOriginHeader()

      Returns:
        whether to add the `origin` header to the WebSocket handshake request

    - #### setAllowOriginHeader

          public WebSocketConnectOptions setAllowOriginHeader(boolean allowOriginHeader)

      Set whether to add the `origin` header to the WebSocket handshake request, enabled by default.

      Set to `false` when a server does not accept WebSocket with an origin header.

      Parameters:
        `allowOriginHeader` - whether to add the `origin` header to the WebSocket handshake request
      Returns:
        a reference to this, so the API can be used fluently

    - #### setHost

          public WebSocketConnectOptions setHost(String host)

      Description copied from class: `RequestOptions`
      Set the host name to be used by the client request.
      Overrides:
        `setHost` in class `RequestOptions`
      Returns:
        a reference to this, so the API can be used fluently

    - #### setPort

          public WebSocketConnectOptions setPort(Integer port)

      Description copied from class: `RequestOptions`
      Set the port to be used by the client request.
      Overrides:
        `setPort` in class `RequestOptions`
      Returns:
        a reference to this, so the API can be used fluently

    - #### setSsl

          public WebSocketConnectOptions setSsl(Boolean ssl)

      Description copied from class: `RequestOptions`
      Set whether SSL/TLS is enabled.
      Overrides:
        `setSsl` in class `RequestOptions`
      Parameters:
        `ssl` - true if enabled
      Returns:
        a reference to this, so the API can be used fluently

    - #### setURI

          public WebSocketConnectOptions setURI(String uri)

      Description copied from class: `RequestOptions`
      Set the request relative URI.
      Overrides:
        `setURI` in class `RequestOptions`
      Parameters:
        `uri` - the relative uri
      Returns:
        a reference to this, so the API can be used fluently

    - #### setTimeout

          public WebSocketConnectOptions setTimeout(long timeout)

      Sets the amount of time after which if the WebSocket handshake does not happen within the timeout period an `WebSocketHandshakeException` will be passed to the exception handler and the connection will be closed.
      Overrides:
        `setTimeout` in class `RequestOptions`
      Parameters:
        `timeout` - the amount of time in milliseconds.
      Returns:
        a reference to this, so the API can be used fluently

    - #### addHeader

          public WebSocketConnectOptions addHeader(String key,
                                                   String value)

      Description copied from class: `RequestOptions`
      Add a request header.
      Overrides:
        `addHeader` in class `RequestOptions`
      Parameters:
        `key` - the header key
        `value` - the header value
      Returns:
        a reference to this, so the API can be used fluently

    - #### addHeader

          public WebSocketConnectOptions addHeader(CharSequence key,
                                                   CharSequence value)

      Description copied from class: `RequestOptions`
      Add a request header.
      Overrides:
        `addHeader` in class `RequestOptions`
      Parameters:
        `key` - the header key
        `value` - the header value
      Returns:
        a reference to this, so the API can be used fluently

    - #### addHeader

          public WebSocketConnectOptions addHeader(CharSequence key,
                                                   Iterable<CharSequence> values)

      Overrides:
        `addHeader` in class `RequestOptions`

    - #### putHeader

          public WebSocketConnectOptions putHeader(String key,
                                                   String value)

      Description copied from class: `RequestOptions`
      Set a request header.
      Overrides:
        `putHeader` in class `RequestOptions`
      Parameters:
        `key` - the header key
        `value` - the header value
      Returns:
        a reference to this, so the API can be used fluently

    - #### putHeader

          public WebSocketConnectOptions putHeader(CharSequence key,
                                                   CharSequence value)

      Description copied from class: `RequestOptions`
      Set a request header.
      Overrides:
        `putHeader` in class `RequestOptions`
      Parameters:
        `key` - the header key
        `value` - the header value
      Returns:
        a reference to this, so the API can be used fluently

    - #### putHeader

          public WebSocketConnectOptions putHeader(CharSequence key,
                                                   Iterable<CharSequence> values)

      Overrides:
        `putHeader` in class `RequestOptions`

    - #### setHeaders

          public WebSocketConnectOptions setHeaders(MultiMap headers)

      Description copied from class: `RequestOptions`
      Set request headers from a multi-map.
      Overrides:
        `setHeaders` in class `RequestOptions`
      Parameters:
        `headers` - the headers
      Returns:
        a reference to this, so the API can be used fluently

    - #### toJson

          public JsonObject toJson()

      Overrides:
        `toJson` in class `RequestOptions`

Copyright © 2022 Eclipse. All rights reserved.